-- debug functions
debugs = {}
function debugs.print(variable, variablename)
	print(variablename..": "..debugs.convert2string(variable, ""))
end

function debugs.convert2string(variable, tabledimension)
	local returnvalue = ""
	local variabletype = type(variable)
	if variabletype == "nil" then returnvalue = "|CFF0000FFnil|r"
	elseif variabletype == "number" 	then returnvalue = "|CFFF7BDDE"..variable.."|r"
	elseif variabletype == "string" 	then returnvalue = "'"..variable.."'"
	elseif variabletype == "boolean" 	then returnvalue = debugs.boolean2string(variable)
	elseif variabletype == "table" 		then returnvalue = debugs.table2string(variable, tabledimension)
	else returnvalue = "unknown variabletype" end
	return returnvalue
end

function debugs.table2string(variable, tabledimension)
	local returnvalue = ""
	local newtabledimension = ""
	for i,v in pairs(variable) do
		newtabledimension = tabledimension.."["..i.."]"
		if type(v) == "table" then returnvalue = returnvalue.." "..debugs.convert2string(v, newtabledimension)
		else print(" |CFF00FF00"..newtabledimension.."|r "..debugs.convert2string(v, newtabledimension)) end
	end
	returnvalue = returnvalue .. " "
	return returnvalue
end

function debugs.boolean2string(variable)
	if variable then return "|CFF94D6E7true|r"
	else return "|CFF94D6E7false|r" end
end