function vexalarm.panel_field()
	return {
		type = "group",
		order= 3,
		args = {
			grptestmode = {
				name = "Test-Mode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate test-mode",
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm.testmode=val vexalarm_test_starter(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name ="As long as the testmode is active, the addon will show a message every few seconds", type = "description", order=2, fontSize="medium"},
					},
				},
			frame_space_testmode = {name ="\n", type = "description", order=2},
			grppos = {
				name = "Position and Size",
				order=10, type ="group", dialogInline = true,
				args = {
					framewidth = {
						name = "width",
						order=1, type = "range",
						desc = "Sets the width of the frame",
						step = 1, min = 1, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["size"]["width"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["size"]["width"] end
						},
					frameheight = {
						name = "height",
						order=2, type = "range",
						desc = "Sets the height of the frame",
						step = 1, min = 1, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["size"]["height"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["size"]["height"] end
						},
					frame_size_space = {name =" ", type = "description", order=3},
					frame_pos_x = {
						name = "X Position",
						order=6, type = "range",
						desc = "Sets the x position of the frame",
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["bg"]["x"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["x"] end
						},
					frame_pos_y = {
						name = "Y Position",
						order=7, type = "range",
						desc = "Sets the y position of the frame",
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["bg"]["y"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["y"] end
						},
					frameanchor = {
						name = "Anchor",
						order=8, type = "select", style = "dropdown",
						desc = "Sets the achor of the frame",
						values = {
							["CENTER"]="Center",
							["BOTTOM"]="Bottom",
							["TOP"]="Top",
							["LEFT"]="Left",
							["RIGHT"]="Right",
							["BOTTOMLEFT"]="Bottomleft",
							["BOTTOMRIGHT"]="Bottomright",
							["TOPLEFT"]="Topleft",
							["TOPRIGHT"]="Topright"},
						set = function(self,key) vexalarm_parameters["frame"]["position"]["bg"]["anchor"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["position"]["bg"]["anchor"] end,
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=11},
				
			grpbg = {
				name = "Background Settings",
				order=12, type ="group", dialogInline = true,
				args = {
					framebackdrop = {
						name = "Background Texture",
						order=1, type = "select",
						dialogControl = "LSM30_Background",
						desc = "Sets the frame's background texture",
						values = vexalarm.LSM:HashTable("background"),
						set = function(self,key) vexalarm_parameters["frame"]["bg"]["texture"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["bg"]["texture"] end,
						},
					bg_space = {name =" ", type = "description", order=2},
					framebgcolor = {
						name = "Background Color",
						order=3, type = "color",
						desc = "Sets the frame's background color",
						hasAlpha = false,
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["bg"]["color"]["r"]=r
							vexalarm_parameters["frame"]["bg"]["color"]["g"]=g
							vexalarm_parameters["frame"]["bg"]["color"]["b"]=b
							vexalarm_initialize(true) end,
						get = function() return
							vexalarm_parameters["frame"]["bg"]["color"]["r"],
							vexalarm_parameters["frame"]["bg"]["color"]["g"],
							vexalarm_parameters["frame"]["bg"]["color"]["b"] end,
						},
					framebgopacity = {
						name = "Opacity %",
						order=4, type = "range",
						desc = "Sets the frame's background opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["bg"]["color"]["a"]=val/100 vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["bg"]["color"]["a"]*100 end
						},
					},
				},
			frame_space2 = {name ="\n", type = "description", order=13},
				
			grpborder = {
				name = "Border Settings",
				order=14, type ="group", dialogInline = true,
				args = {
					bordertexture = {
						name = "Border texture",
						order=1, type = "select",
						dialogControl = "LSM30_Border",
						desc = "Sets the frame's border texture",
						values = vexalarm.LSM:HashTable("border"),
						set = function(self,key) vexalarm_parameters["frame"]["border"]["texture"]=key vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["texture"] end,
						},
					bordersize = {
						name = "Border size",
						order=2, type = "range",
						desc = "Sets the frame's border size",
						step = 1, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["border"]["size"]=val vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["size"] end,
						},
					border_space = {name =" ", type = "description", order=3},
					bordercolor = {
						name = "Border Color",
						order=4, type = "color",
						desc = "Sets the frame's border color",
						hasAlpha = false,
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["border"]["color"]["r"]=r
							vexalarm_parameters["frame"]["border"]["color"]["g"]=g
							vexalarm_parameters["frame"]["border"]["color"]["b"]=b
							vexalarm_initialize(true) end,
						get = function() return
							vexalarm_parameters["frame"]["border"]["color"]["r"],
							vexalarm_parameters["frame"]["border"]["color"]["g"],
							vexalarm_parameters["frame"]["border"]["color"]["b"] end,
						},
					frameborderopacity = {
						name = "Opacity %",
						order=5, type = "range",
						desc = "Sets the frame's border opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["border"]["color"]["a"]=val/100 vexalarm_initialize(true) end,
						get = function() return vexalarm_parameters["frame"]["border"]["color"]["a"]*100 end
						},
					}
				},
			},
		}
end