vexalarm.testmode = false

function vexalarm.panel_msgs()
	return {
		type = "group",
		order= 1,
		args = {
			grptestmode = {
				name = "Test-Mode",
				order=1, type ="group", dialogInline = true,
				args = {
					testmode = {
						name = "Activate test-mode",
						order=1, type = "toggle", width="full",
						set = function(info,val) vexalarm.testmode=val vexalarm_test_starter(val) end,
						get = function() return vexalarm.testmode end,
						},
					testmodeinfo = {name ="As long as the testmode is active, the addon will show a message every few seconds", type = "description", order=2, fontSize="medium"},
					},
				},
			frame_space = {name ="\n", type = "description", order=2},
			grptextformat = {
				name = "Text Format",
				order=3, type ="group", dialogInline = true,
				args = {
					textfont = {
						name = "Text font",
						order=1, type = "select",
						dialogControl = "LSM30_Font",
						desc = "Sets the font for the messages",
						values = vexalarm.LSM:HashTable("font"),
						set = function(self,key) vexalarm_parameters["frame"]["text"]["font"]=key end,
						get = function() return vexalarm_parameters["frame"]["text"]["font"] end,
						},
					textsize = {
						name = "Text Size",
						order=2, type = "range",
						desc = "Sets the font size for the messages",
						step = 1, min = 6, max = 20,
						set = function(info,val) vexalarm_parameters["frame"]["text"]["size"]=val end,
						get = function() return vexalarm_parameters["frame"]["text"]["size"] end,
						},
					fontalign = {
						name = "Text align",
						order=3, type = "select", style = "dropdown",
						desc = "Sets the alignment of the text",
						values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
						set = function(self,key) vexalarm_parameters["frame"]["text"]["align"]=key end,
						get = function() return vexalarm_parameters["frame"]["text"]["align"] end,
						},
					fontoutline = {
						name = "Text effect",
						order=3, type = "select", style = "dropdown",
						desc = "Sets the alignment of the text",
						values = {["MONOCHROME"]="None", ["OUTLINE"]="Outline", ["THICKOUTLINE"]="Thickoutline"},
						set = function(self,key) vexalarm_parameters["frame"]["text"]["outline"]=key end,
						get = function() return vexalarm_parameters["frame"]["text"]["outline"] end,
						},
					},
				},
			frame_spacefont = {name ="\n", type = "description", order=4},
			grpevents = {
				name = "Event Settings",
				order=5, type ="group", dialogInline = true,
				args = {
					alarmx = {
						name = "X Position",
						order=1, type = "range",
						desc = "Distance from the left part of the frame to the message",
						step = 1, min = 1, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["alarm"]["x"]=val end,
						get = function() return vexalarm_parameters["frame"]["position"]["alarm"]["x"] end,
						},
					alarmy = {
						name = "Y Position",
						order=2, type = "range",
						desc = "Distance from the top part of the frame to the message",
						step = 1, min = -100, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["alarm"]["y"]=val end,
						get = function() return vexalarm_parameters["frame"]["position"]["alarm"]["y"] end,
						},
					frame_events_space = {name ="\n", type = "description", order=3},
					alarmspacing = {
						name = "Distance between events",
						order=6, type = "range",
						desc = "Sets the distance between the individual events",
						step = 1, min = 1, max = 100,
						set = function(info,val) vexalarm_parameters["frame"]["position"]["alarm"]["spacing"]=val end,
						get = function() return vexalarm_parameters["frame"]["position"]["alarm"]["spacing"] end,
						},
					alarmcount = {
						name = "Maximum shown events",
						order=7, type = "range",
						desc = "Sets the amount of maximum shown messages",
						step = 1, min = 1, max = 20,
						set = function(info,val) vexalarm_parameters["frame"]["maxevents"]=val end,
						get = function() return vexalarm_parameters["frame"]["maxevents"] end,
						},
					alarmdownwars = {
						name = "arrange events upwards, instead of downwards",
						order=8, type = "toggle", width="double",
						set = function(info,val) vexalarm_parameters["frame"]["scrolldown"]=val end,
						get = function() return vexalarm_parameters["frame"]["scrolldown"] end,
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=6},
			
			grptextcolors = {
				name = "Text Colors",
				order=7, type ="group", dialogInline = true,
				args = {
					statuscolor1 = {
						name = "{status_sc} active",
						order=1, type = "color", width="",
						desc = "Color for the status text when a buff/spell becomes active",
						set = function(info,r,g,b)
							vexalarm_parameters["colors"]["active"]["HEX"] = vexalarm_dec2hex(r,g,b)
							vexalarm_parameters["colors"]["active"]["r"] = r
							vexalarm_parameters["colors"]["active"]["g"] = g
							vexalarm_parameters["colors"]["active"]["b"] = b end,
						get = function() return
							vexalarm_parameters["colors"]["active"]["r"],
							vexalarm_parameters["colors"]["active"]["g"],
							vexalarm_parameters["colors"]["active"]["b"] end,
						},
					statusmsgcolor1 = {
						name = "text color for buff gained/cast succeded",
						order=2, type = "color", width="double",
						desc = "color for the message text when spell is cast or a buff is gained",
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["text"]["color"]["active"]["r"] = r
							vexalarm_parameters["frame"]["text"]["color"]["active"]["g"] = g
							vexalarm_parameters["frame"]["text"]["color"]["active"]["b"] = b end,
						get = function() return
							vexalarm_parameters["frame"]["text"]["color"]["active"]["r"],
							vexalarm_parameters["frame"]["text"]["color"]["active"]["g"],
							vexalarm_parameters["frame"]["text"]["color"]["active"]["b"] end,
						},
					statuscolor2 = {
						name = "{status_sc} inactive",
						order=3, type = "color", width="",
						desc = "Color for the status text when a buff/spell becomes inactive",
						set = function(info,r,g,b)
							vexalarm_parameters["colors"]["inactive"]["HEX"] = vexalarm_dec2hex(r,g,b)
							vexalarm_parameters["colors"]["inactive"]["r"] = r
							vexalarm_parameters["colors"]["inactive"]["g"] = g
							vexalarm_parameters["colors"]["inactive"]["b"] = b end,
						get = function() return
							vexalarm_parameters["colors"]["inactive"]["r"],
							vexalarm_parameters["colors"]["inactive"]["g"],
							vexalarm_parameters["colors"]["inactive"]["b"] end,
						},
					statusmsgcolor2 = {
						name = "text color for buff lost",
						order=4, type = "color", width="double",
						desc = "color for the message text when a buff is lost",
						set = function(info,r,g,b,a)
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["r"] = r
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["g"] = g
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["b"] = b end,
						get = function() return
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["r"],
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["g"],
							vexalarm_parameters["frame"]["text"]["color"]["inactive"]["b"] end,
						},
					frame_textspace3 = {name ="\n\n", type = "description", order=5},
					
					castercolor = {
						name = "{caster_sc}",
						order=6, type = "color", width="full",
						desc = "Color for the caster, when the message contains {caster_sc}",
						set = function(info,r,g,b)
							vexalarm_parameters["colors"]["caster_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
							vexalarm_parameters["colors"]["caster_sc"]["r"] = r
							vexalarm_parameters["colors"]["caster_sc"]["g"] = g
							vexalarm_parameters["colors"]["caster_sc"]["b"] = b end,
						get = function() return
							vexalarm_parameters["colors"]["caster_sc"]["r"],
							vexalarm_parameters["colors"]["caster_sc"]["g"],
							vexalarm_parameters["colors"]["caster_sc"]["b"] end,
						},
					targetcolor = {
						name = "{target_sc}",
						order=7, type = "color", width="full",
						desc = "Color for the target, when the message contains {target_sc}",
						set = function(info,r,g,b)
							vexalarm_parameters["colors"]["target_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
							vexalarm_parameters["colors"]["target_sc"]["r"] = r
							vexalarm_parameters["colors"]["target_sc"]["g"] = g
							vexalarm_parameters["colors"]["target_sc"]["b"] = b end,
						get = function() return
							vexalarm_parameters["colors"]["target_sc"]["r"],
							vexalarm_parameters["colors"]["target_sc"]["g"],
							vexalarm_parameters["colors"]["target_sc"]["b"] end,
						},
					spellcolor = {
						name = "{spell_sc}",
						order=8, type = "color", width="full",
						desc = "Color for the spellname, when the message contains {spell_sc}",
						set = function(info,r,g,b)
							vexalarm_parameters["colors"]["spell_sc"]["HEX"] = vexalarm_dec2hex(r,g,b)
							vexalarm_parameters["colors"]["spell_sc"]["r"] = r
							vexalarm_parameters["colors"]["spell_sc"]["g"] = g
							vexalarm_parameters["colors"]["spell_sc"]["b"] = b end,
						get = function() return
							vexalarm_parameters["colors"]["spell_sc"]["r"],
							vexalarm_parameters["colors"]["spell_sc"]["g"],
							vexalarm_parameters["colors"]["spell_sc"]["b"] end,
						},
				
					},
				},
			frame_space2 = {name ="\n", type = "description", order=8},
			
			grptimedata = {
				name = "Time data",
				order=9, type ="group", dialogInline = true,
				args = {
					allowvanish = {
						name = "Allow 'fade-out'-effect",
						order=1, type = "toggle", width="full",
						desc = "Enabling this lets the events fade out",
						set = function(info,val) vexalarm_parameters["timedata"]["allowvanish"]=val end,
						get = function() return vexalarm_parameters["timedata"]["allowvanish"] end,
						},
					timedataspace = {name =" ", type = "description", order=2},
					alarmshowtime = {
						name = "Duration: message",
						order=2, type = "range",
						desc = "How long events are shown before they fade out",
						step = 1, min = 1, max = 10,
						set = function(info,val) vexalarm_parameters["timedata"]["show"]=val end,
						get = function() return vexalarm_parameters["timedata"]["show"] end,
						},
					alarmvanishtime = {
						name = "Duration: 'fade-out' effect",
						order=3, type = "range",
						desc = "How long events are fading out",
						step = 1, min = 1, max = 10,
						set = function(info,val) vexalarm_parameters["timedata"]["vanish"]=val end,
						get = function() return vexalarm_parameters["timedata"]["vanish"] end,
						},
					},
				},
			frame_space3 = {name ="\n", type = "description", order=10},
			
			grpdeirmode = {
				name = "'DEIR'-mode",
				order=11, type ="group", dialogInline = true,
				args = {
					moveuptext = {name ="In 'DEIR'-mode (Dead Events in Idle Rotatestate) the events don't move up anymore when an event-message which is displayed above them expired. They stay at their location where they are first shown.", type = "description", order=123, fontSize="medium"},
					allowmoveup = {
						name = "Activate DEIR-mode",
						order=123, type = "toggle", width="full",
						desc = "",
						set = function(info,val) vexalarm_parameters["frame"]["allowscrolling"]=not(val) end,
						get = function() return not(vexalarm_parameters["frame"]["allowscrolling"]) end,
						},
					},
				},
			}
		}
end