function vexalarm.panel_sounds()
	return {
		type = "group",
		args = {
			grpallow = {
				name = "General Settings",
				order=1, type ="group", dialogInline = true,
				args = {
					allowsounds = {
						name = "Allow Sounds",
						order=1, type = "toggle",
						desc = "Allow sounds",
						set = function(info,val) vexalarm_parameters["sounds"]["allow"]=val end,
						get = function() return vexalarm_parameters["sounds"]["allow"] end,
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=2},
			
			grpbuff = {
				name = "Buffs",
				order=3, type ="group", dialogInline = true,
				args = {
					grpactive = {
						name = "Active Buffs",
						order=3, type ="group", dialogInline = true,
						args = {
							activesound = {
								name = "Sound",
								order=11, type = "select",
								dialogControl = "LSM30_Sound",
								desc = "Sets the sound that is played when a buff becomes active",
								values = vexalarm.LSM:HashTable("sound"),
								set = function(self,key) vexalarm_parameters["sounds"]["active"]["file"] = key end,
								get = function() return vexalarm_parameters["sounds"]["active"]["file"] end,
								},
							activesoundchannel = {
								name = "Channel",
								order=12, type = "select", style = "dropdown",
								desc = "Sets the sound's channel that is used to play the sound",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								set = function(self,key) vexalarm_parameters["sounds"]["active"]["channel"] = key  end,
								get = function() return vexalarm_parameters["sounds"]["active"]["channel"] end,
								},
							},
						},
					frame_space2 = {name ="\n", type = "description", order=4},
					
					grpinactive = {
						name = "Inctive Buffs",
						order=5, type ="group", dialogInline = true,
						args = {
							inactivesound = {
								name = "Sound",
								order=21, type = "select",
								dialogControl = "LSM30_Sound",
								desc = "Sets the sound that is played when a buff becomes inactive",
								values = vexalarm.LSM:HashTable("sound"),
								set = function(self,key) vexalarm_parameters["sounds"]["inactive"]["file"] = key end,
								get = function() return vexalarm_parameters["sounds"]["inactive"]["file"] end,
								},
							inactivesoundchannel = {
								name = "Channel",
								order=22, type = "select", style = "dropdown",
								desc = "Sets the sound's channel that is used to play the sound",
								values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
								set = function(self,key) vexalarm_parameters["sounds"]["inactive"]["channel"] = key end,
								get = function() return vexalarm_parameters["sounds"]["inactive"]["channel"] end,
								},
							},
						},
					},
				},
			frame_space3 = {name ="\n", type = "description", order=5},
			
			grpcast = {
				name = "Casts",
				order=6, type ="group", dialogInline = true,
				args = {
					inactivesound = {
						name = "Sound",
						order=21, type = "select",
						dialogControl = "LSM30_Sound",
						desc = "Sets the sound when a spell has been cast",
						values = vexalarm.LSM:HashTable("sound"),
						set = function(self,key) vexalarm_parameters["sounds"]["cast"]["file"] = key end,
						get = function() return vexalarm_parameters["sounds"]["cast"]["file"] end,
						},
					inactivesoundchannel = {
						name = "Channel",
						order=22, type = "select", style = "dropdown",
						desc = "Sets the sound's channel that is used to play the sound",
						values = {["Master"]="Master", ["SFX"]="SFX", ["Ambience"]="Ambience", ["Music"]="Music"},
						set = function(self,key) vexalarm_parameters["sounds"]["cast"]["channel"] = key end,
						get = function() return vexalarm_parameters["sounds"]["cast"]["channel"] end,
						},
					},
				},
			}
		}
end
