local vexalarm_spellprofiles_profile_load = ""
local vexalarm_spellprofiles_profile_delete = ""
local vexalarm_spellprofiles_profile_new = ""

function vexalarm.panel_spellprofiles()

	return {
		type = "group",
		args = {
			grpex = {
				name = "Information",
				order=1, type = "group", dialogInline = true,
				args = {
					info1={name = "You can save your current spell settings in profiles and load them later on. That way you can switch between profiles to adjust your settings for specific situations", type="description", order=2, fontSize="medium"},
					space1={name= " ", type="description", order=10},
					},
				},
			frame_space1 = {name =" ", type = "description", order=2},
			grpadd = {
				name = "Add Profile",
				order=3, type ="group", dialogInline = true,
				args = {
					profile_new = {
						name = "Name",
						desc = "Enter a name for the new profile",
						order=1, type = "input", multiline = false, width = "double",
						validate = function (info, val)
							if vexalarm_profile_checkName(val) then return true
							else return "ERROR - "..val.." is not a valid name" end
							end,
						set = function(info,val) vexalarm_spellprofiles_profile_new = val end,
						get = function() return vexalarm_spellprofiles_profile_new end,
						},
					profile_new_add = {
						name = "add", width="half",
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_add() end,
						},
					grpadddelete_allowed = {name ="Profile names may only contain numbers, letters and spaces", type = "description", order=3, fontSize="medium"},
					},
				},
			frame_space2 = {name =" ", type = "description", order=4},
			grpdelete = {
				name = "Delete Profile",
				order=5, type ="group", dialogInline = true,
				args = {
					profile_delete = {
						name = "Profile",
						order=1, type = "select", style = "dropdown",
						desc = "Delete an existing profile",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_delete = key end,
						get = function() return vexalarm_spellprofiles_profile_delete end,
						},
					delete_exe = {
						name = "delete",
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_delete() end,
						confirm = true,
						confirmText = "Are you sure you want to delete the profile?"
						},
					},
				},
			frame_space3 = {name =" ", type = "description", order=6},
			grpload = {
				name = "Load Profile",
				order=7, type ="group", dialogInline = true,
				args = {
					profile_load = {
						name = "Profile",
						order=1, type = "select", style = "dropdown",
						values = vexalarm_spellprofiles["profilelist"],
						set = function(self,key) vexalarm_spellprofiles_profile_load = key end,
						get = function() return vexalarm_spellprofiles_profile_load end,
						},
					load_exe = {
						name = "load",
						order=2, type = "execute",
						func = function(info,val) vexalarm_spellprofile_add() vexalarm_initialize(true) end,
						},
					grpload_info = {name = "\nYou can load spell-profiles with slash-commands\n'/vexalarm profile test' makes the addon load the profile with the name 'test'", type = "description", order=3, fontSize="medium"},
					},
				},
			}
		}
end

function vexalarm_profile_checkName(val)
	local returnvalue = false
	local val_edited = string.gsub(val, "%a", "")
	val_edited = string.gsub(val_edited, "%d", "")
	val_edited = string.gsub(val_edited, " ", "")
	if val_edited == "" then returnvalue = true end
	if val == "" or val == "profilelist" then returnvalue = false end
	return returnvalue
end

function vexalarm_spellprofile_add()
	local key = vexalarm_spellprofiles_profile_new
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = key
		vexalarm_spellprofiles[key] = vexalarm_CopyTable(vexalarm_spells)
		vexalarm_spellprofiles_profile_new = ""
		debugs.print(vexalarm_spellprofiles["profilelist"], 'vexalarm_spellprofiles["profilelist"]')
	end
end

function vexalarm_spellprofile_delete(key)
	if key == nil then key = vexalarm_spellprofiles_profile_delete end
	if key ~= "" then
		vexalarm_spellprofiles["profilelist"][key] = nil
		vexalarm_spellprofiles[key] = nil
	end
	vexalarm_spellprofiles_profile_delete = ""
end

function vexalarm_spellprofile_load(key, slashcmd)
	if key == nil then key = vexalarm_spellprofiles_profile_load end
	if key ~= "" then
		if vexalarm_spellprofiles[key] == nil then print("|CFFFF7D0AVex Alarm|r - Error: Spell-Profile not found")
		else
			vexalarm_spells = vexalarm_CopyTable(vexalarm_spellprofiles[key])
			if slashcmd then print("|CFFFF7D0AVex Alarm|r - Profile '"..key.."' loaded") end
		end
	end
	vexalarm_spellprofiles_profile_load = ""
end

-- thx to Lombra from WoWAce for this function
function vexalarm_CopyTable(settings)
	local copy = {}
	for k, v in pairs(settings) do
		if type(v) == "table" then  copy[k] = vexalarm_CopyTable(v)
		else						copy[k] = v end
	end
	return copy
end



