function vexalarm.panel_spells(ID)
				
	local grps = {"", "Buffs", "Selfbuffs", "Groupbuffs", "Casts with targets", "Casts without targets"}
	
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local classnames2 = {"Death Knight", "Druid", "Hunter", "Mage", "Monk", "Paladin", "Priest", "Rogue", "Shaman", "Warlock", "Warrior", "not-class-specific spells"}
	local rolenames = {"all", "tank", "heal", "dd", "role not set"}
	local orderStartvalue = 100
	local enable = {
			{"+", "enable", true},
			{"-", "disable", false}
			}
			
	local definitiontexts = {"",
			"'buff'-spells are buffs that have a single target",
			"'selfbuff'-spells are buffs that have no target and are mostly casted on yourself",
			"'grpbuff'-spells are buffs that effect multiple targets",
			"'cast'-spells are spells that have a target",
			"'selfcast'-spells are spells that have no target and are mostly casted on yourself",
			}
	
	local options = {
		type = "group",
		args = {
			newspells = {name = "If you're missing a spell and want it added to the list, feel free to contact me\nhttp://www.wowace.com/addons/cdalarm\n",
					type="description", fontSize="medium", order=1},
			definitiongrp = { name = "Definition", type="group", order= 2, dialogInline = true,
				args = { definitiontext = {name = definitiontexts[ID], type="description", fontSize="medium", order=1}, },
				}
			}
		}
	
	
	local optiongrp = {
		name = grps[ID], type = "group", dialogInline = true, args = {}, order=10,
		}
		
	local rank = 0
	local tablenumber = ID-1
	
	local spelltype = ""
	if 		tablenumber == 1 	then spelltype = "buff"
	elseif 	tablenumber == 2 	then spelltype = "selfbuff"
	elseif 	tablenumber == 3 	then spelltype = "grpbuff"
	elseif 	tablenumber == 4 	then spelltype = "instant"
	elseif 	tablenumber == 5 	then spelltype = "instantself" end
	
	-- +/- buttons
	local role = 0
	for i=1,5 do
		for j=1,2 do
			if i == 1 then 	role = nil		rank = (j*15)+1
			else 			role = i-1 		rank = i+(10*j) end
			optiongrp.args[tostring(ID).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm_spelloptions_button(rolenames[i], spelltype, enable[j], role, rank)
		end
	end
	
	options.args["buttons"] = optiongrp
	
	local spellrank = 0
	for i=1,#classnames do
		local spelllist = vexalarm_gen_alphabetical_spelllist(spelltype, classnames[i])
		local filledspells = false
		
		local spellclassgrp = { name = classnames2[i], type = "group", dialogInline = true, args = {}, order=10+i*2, }
		for j in ipairs(spelllist) do
			local key = spelllist[j][2]
			spellrank = spellrank + 1
			rank = (spellrank*10)+100
			options.args["space"..i] = {name = "\n", type="description", order=9+i*2}
			
			spellclassgrp.args[tostring(rank)] = vexalarm_spelloptions_description(key, rank)
			
			for z=1,4 do
				spellclassgrp.args[tostring(rank+z)] = vexalarm_spelloptions_toggle(rolenames[z+1], key, z, rank+z)
			end
					
			if j ~= #spelllist then spellclassgrp.args[tostring(rank+5)] = {name = "\n", type="description", order=rank+5} end	
			filledspells = true
		end
		if filledspells then options.args["spells"..i] = spellclassgrp end
	end
	

	return options
end

function vexalarm_gen_alphabetical_spelllist(spelltype, class)
	local returnvalue = {}
	-- get all spells of the category
	local place = 1
	for key, val in pairs(vexalarm_spells_defaults) do	
		if val[6] == spelltype and val[5] == class then
			returnvalue[place] = {select(1, GetSpellInfo(tonumber(key))), key}
			place = place + 1
		end
	end
	table.sort(returnvalue, function(a,b) return a[1]<b[1] end)
	return returnvalue
end

function vexalarm_spelloptions_button(rolestring, spelltype, enable, role, rank)
	local returnvalue = {
		name = enable[1].." "..rolestring,
		func = function(info,val) vexalarm_spelltoggle(spelltype, enable[3], role) end,
		order=rank, type = "execute",}
	if role~=4 then returnvalue.width="half" end
	if role == nil then returnvalue.desc = enable[2].." all spells"
	else 				returnvalue.desc = enable[2].." all spells where the caster's role is '"..rolestring.."'" end
	return returnvalue
end

function vexalarm_spelloptions_description(key, rank)
	local iconfile = select(3, GetSpellInfo(tonumber(key)))
	local spellname = select(1, GetSpellInfo(tonumber(key)))
	local temp = {fontSize="large", image = iconfile, type="description", order=rank}
	if 		key == "86669" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." (holy)"
	elseif 	key == "86698" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." (retri.)"
	elseif 	key == "86659" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." (prot.) (broken)"
	elseif 	key == "77764" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." (cat form)"
	elseif 	key == "77761" then temp.name = vexalarm_colorize_class(spellname, key, "spell").." (bear form)"
	else 						temp.name = vexalarm_colorize_class(spellname, key, "spell") end
	return temp
end

function vexalarm_spelloptions_toggle(rolestring, key, role, rank)	
	local returnvalue = {
						name = rolestring,
						order=rank, type = "toggle",
						desc = "Shall Vex Alarm post an alarm when the caster's role is "..rolestring,
						set = function(info,val)
							if vexalarm_spells[key] == nil then vexalarm_spells[key]={} end
							vexalarm_spells[key][role]=val end,
						get = function()
							if vexalarm_spells[key]==nil then return false
							else return vexalarm_spells[key][role] end	end
						}
	
	if role ~= 4 then returnvalue.width="half" end
	return returnvalue
end

function vexalarm_spelltoggle(spelltype, val, role)
	if spelltype ~=nil then
		for tablekey,tableval in pairs(vexalarm_spells) do
			if tableval[6] == spelltype then
				if role ~=nil then vexalarm_spells[tablekey][role] = val
				else
					for i=1,4 do
						vexalarm_spells[tablekey][i] = val
					end
				end
			end
		end
	else
		vexalarm_spelltoggle("buff", val, role)
		vexalarm_spelltoggle("selfbuff", val, role)
		vexalarm_spelltoggle("grpbuff", val, role)
		vexalarm_spelltoggle("instant", val, role)
		vexalarm_spelltoggle("instantself", val, role)
	end
end

